/*
 *
 *     This file is part of the Squashtest platform.
 *     Copyright (C) 2017 Henix, henix.fr
 *
 *     See the NOTICE file distributed with this work for additional
 *     information regarding copyright ownership.
 *
 *     This is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU Lesser General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     this software is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU Lesser General Public License for more details.
 *
 *     You should have received a copy of the GNU Lesser General Public License
 *     along with this software.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.squashtest.tm.plugin.rest.validators;

import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;
import org.squashtest.tm.domain.project.GenericProject;
import org.squashtest.tm.plugin.rest.jackson.model.GenericProjectCopyParameterDto;
import org.squashtest.tm.plugin.rest.jackson.model.GenericProjectDto;
import org.squashtest.tm.plugin.rest.jackson.model.GenericProjectDtoVisitor;
import org.squashtest.tm.plugin.rest.jackson.model.ProjectDto;
import org.squashtest.tm.plugin.rest.jackson.model.ProjectTemplateDto;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

@Component
public class GenericProjectPostValidator implements Validator {

    private static final String PARAMS_FIELD  = "params";
    private static final String INCONSISTENT_PARAM_VALUES_ERROR_CODE  = "inconsistent parameter values";


    @PersistenceContext
    protected EntityManager entityManager;

    @Override
    public boolean supports(Class<?> clazz) {
        return GenericProjectDto.class.isAssignableFrom(clazz);
    }

    @Override
    public void validate(Object target, final Errors errors) {

        GenericProjectDto genericProjectDto = (GenericProjectDto) target;

        if (genericProjectDto.getId() != null) {
            errors.rejectValue("id", "generated value", "This attribute is generated by database and should not be provided. If you want to update an existing generic project, please do a patch request to the generic project id. ");
        }

        ValidationUtils.rejectIfEmptyOrWhitespace(errors, "name", "required", "This attribute can't be empty");

        GenericProjectDtoVisitor visitor = new GenericProjectDtoVisitor() {
            @Override
            public void visit(ProjectDto projectDto) {
                if (projectDto.getTemplateId() != null) {
                    checkAndAssignValues(projectDto);
                    validateTemplateBindingConsistency(errors, projectDto);
                    validatePluginBindingConsistency(errors, projectDto);
                    checkIfEntityExist(errors, projectDto.getTemplateId());
                }
            }

            @Override
            public void visit(ProjectTemplateDto projectTemplateDto) {
                if (projectTemplateDto.getProjectId() != null) {
                    checkAndAssignValues(projectTemplateDto);
                    validateCopyParametersConsistency(errors, projectTemplateDto);
                    checkIfEntityExist(errors, projectTemplateDto.getProjectId());
                }
            }
        };

        genericProjectDto.accept(visitor);
    }

    private void checkAndAssignValues(GenericProjectDto genericProjectDto) {
        if (genericProjectDto.getParams() == null) {
            genericProjectDto.setParams(new GenericProjectCopyParameterDto());
        }
    }

    private void checkIfEntityExist(Errors errors, Long id) {
        GenericProject genericProject = entityManager.find(GenericProject.class, id);
        if (genericProject == null) {
            String message = String.format("No project of project template known for id %d", id);
            errors.rejectValue("id", "invalid id", message);
        }
    }

    /**
     * Validates the consistency of plugin binding parameters.
     * This method ensures that:
     *   If {@code copyPluginsConfiguration} is true, both {@code copyCUF} and {@code copyInfolists} must also be true.
     *   If {@code keepPluginsBinding} is true, both {@code copyPluginsConfiguration} and {@code keepTemplateBinding} must also be true.
     * If these conditions are not met, corresponding validation errors are added to the {@link Errors} object.
     * @param errors the {@link Errors} object used to store validation errors
     * @param genericProjectDto the {@link GenericProjectDto} containing the project parameters to validate
     */
    private void validatePluginBindingConsistency(Errors errors, GenericProjectDto genericProjectDto) {
        GenericProjectCopyParameterDto copyParams  = genericProjectDto.getParams();
        boolean keepTemplateBinding = copyParams.isKeepTemplateBinding();
        boolean keepPluginsBinding = copyParams.isKeepPluginsBinding();
        boolean copyPluginsConfiguration = copyParams.isCopyPluginsConfiguration();
        boolean copyCuf = copyParams.isCopyCUF();
        boolean copyInfolists = copyParams.isCopyInfolists();

        if (copyPluginsConfiguration && !(copyCuf && copyInfolists)) {
            errors.rejectValue(
                PARAMS_FIELD,
                INCONSISTENT_PARAM_VALUES_ERROR_CODE ,
                "Inconsistent parameter values: 'copy_cuf' and 'copy_infolists' must be both set to true when 'copy_plugins_configuration' is true."
            );
        }

        if (keepPluginsBinding && !(copyPluginsConfiguration && keepTemplateBinding)) {
            errors.rejectValue(
                PARAMS_FIELD,
                INCONSISTENT_PARAM_VALUES_ERROR_CODE ,
                "Inconsistent parameter values: 'copy_plugins_configuration' and 'keep_template_binding' must be both set to true when 'keep_plugins_binding' is true."
            );
        }
    }

    /**
     * Validates the consistency of copy parameters when the "keepTemplateBinding" flag is set to true.
     * Ensures that if {@code keepTemplateBinding} is true, the following parameters must also be true:
     *   {@code copyCUF}
     *   {@code copyInfolists}
     *   {@code copyAllowTcModifFromExec}
     *   {@code copyOptionalExecStatuses}
     * If any of these parameters are false, an error is added to the provided {@link Errors} object.
     *
     * @param errors the {@link Errors} object to store validation errors
     * @param genericProjectDto the {@link GenericProjectDto} containing the project parameters to validate
     */
    private void validateTemplateBindingConsistency (Errors errors, GenericProjectDto genericProjectDto) {
        GenericProjectCopyParameterDto copyParams  = genericProjectDto.getParams();
        boolean keepTemplateBinding = copyParams.isKeepTemplateBinding();
        boolean copyCuf = copyParams.isCopyCUF();
        boolean copyInfolists = copyParams.isCopyInfolists();
        boolean copyAllowTcModifFromExec = copyParams.isCopyAllowTcModifFromExec();
        boolean copyOptionalExecStatuses = copyParams.isCopyOptionalExecStatuses();

        if (keepTemplateBinding &&
            !(copyCuf && copyInfolists && copyAllowTcModifFromExec && copyOptionalExecStatuses)) {
            errors.rejectValue(
                PARAMS_FIELD,
                INCONSISTENT_PARAM_VALUES_ERROR_CODE ,
                "Inconsistent parameter values: 'copy_cuf', 'copy_infolists', 'copy_allow_tc_modif_from_exec' and 'copy_optional_exec_statuses' must be all true when 'keep_template_binding' is true."
            );
        }
    }

    /**
     * Validates the consistency of the project copy parameters within the provided {@code GenericProjectDto}.
     * Ensures that if {@code copyPluginsConfiguration} is set to {@code true}, then {@code copyCUF},
     * {@code copyInfolists}, and {@code copyPluginsActivation} must also be {@code true}.
     * If the parameters are inconsistent, an error is added to the {@code errors} object.
     *
     * @param errors              the object used to collect validation errors
     * @param genericProjectDto   the DTO containing the project copy parameters to validate
     */
    private void validateCopyParametersConsistency(Errors errors, GenericProjectDto genericProjectDto) {
        GenericProjectCopyParameterDto copyParams  = genericProjectDto.getParams();
        boolean copyCuf = copyParams.isCopyCUF();
        boolean copyInfolists = copyParams.isCopyInfolists();
        boolean copyPluginsActivation = copyParams.isCopyPluginsActivation();
        boolean copyPluginsConfiguration = copyParams.isCopyPluginsConfiguration();
        if (copyPluginsConfiguration && !(copyCuf && copyInfolists && copyPluginsActivation)) {
            errors.rejectValue(
                PARAMS_FIELD,
                INCONSISTENT_PARAM_VALUES_ERROR_CODE ,
                "Inconsistent parameter values: 'copy_cuf', 'copy_infolists' and 'copy_plugins_activation' must be all true when 'copy_plugins_configuration' is true."
            );
        }
    }
}
